// **********************************************************************
//
// Copyright (c) 2003
// ZeroC, Inc.
// Billerica, MA, USA
//
// All Rights Reserved.
//
// Ice is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License version 2 as published by
// the Free Software Foundation.
//
// **********************************************************************

// Ice version 1.2.0
// Generated from file `hello.ice'

#include <hello.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 10200
#       error Ice version mismatch!
#   endif
#endif

void
IceInternal::incRef(::HelloWorld* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::HelloWorld* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::HelloWorld* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::HelloWorld* p)
{
    p->__decRef();
}

void
IceInternal::checkedCast(const ::Ice::ObjectPrx& b, ::HelloWorldPrx& d)
{
    d = 0;
    if(b.get())
    {
	d = dynamic_cast< ::IceProxy::HelloWorld*>(b.get());
	if(!d && b->ice_isA("::HelloWorld"))
	{
	    d = new ::IceProxy::HelloWorld;
	    d->__copyFrom(b);
	}
    }
}

void
IceInternal::checkedCast(const ::Ice::ObjectPrx& b, const ::std::string& f, ::HelloWorldPrx& d)
{
    d = 0;
    if(b)
    {
	::Ice::ObjectPrx bb = b->ice_appendFacet(f);
	try
	{
	    if(bb->ice_isA("::HelloWorld"))
	    {
		d = new ::IceProxy::HelloWorld;
		d->__copyFrom(bb);
	    }
	}
	catch(const ::Ice::FacetNotExistException&)
	{
	}
    }
}

void
IceInternal::uncheckedCast(const ::Ice::ObjectPrx& b, ::HelloWorldPrx& d)
{
    d = 0;
    if(b)
    {
	d = dynamic_cast< ::IceProxy::HelloWorld*>(b.get());
	if(!d)
	{
	    d = new ::IceProxy::HelloWorld;
	    d->__copyFrom(b);
	}
    }
}

void
IceInternal::uncheckedCast(const ::Ice::ObjectPrx& b, const ::std::string& f, ::HelloWorldPrx& d)
{
    d = 0;
    if(b)
    {
	::Ice::ObjectPrx bb = b->ice_appendFacet(f);
	d = new ::IceProxy::HelloWorld;
	d->__copyFrom(bb);
    }
}

void
__write(::IceInternal::BasicStream* __os, const ::HelloWorldPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
__read(::IceInternal::BasicStream* __is, ::HelloWorldPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::HelloWorld;
	v->__copyFrom(proxy);
    }
}

void
__write(::IceInternal::BasicStream* __os, const ::HelloWorldPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceProxy::HelloWorld::sayHello(const ::std::string& name)
{
    sayHello(name, __defaultContext());
}

void
IceProxy::HelloWorld::sayHello(const ::std::string& name, const ::Ice::Context& __ctx)
{
    int __cnt = 0;
    while(true)
    {
	try
	{
	    ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase = __getDelegate();
	    ::IceDelegate::HelloWorld* __del = dynamic_cast< ::IceDelegate::HelloWorld*>(__delBase.get());
	    __del->sayHello(name, __ctx);
	    return;
	}
	catch(const ::IceInternal::NonRepeatable& __ex)
	{
	    __rethrowException(*__ex.get());
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    __handleException(__ex, __cnt);
	}
    }
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::HelloWorld::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::HelloWorld);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::HelloWorld::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::HelloWorld);
}

bool
IceProxy::operator==(const ::IceProxy::HelloWorld& l, const ::IceProxy::HelloWorld& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::operator!=(const ::IceProxy::HelloWorld& l, const ::IceProxy::HelloWorld& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::operator<(const ::IceProxy::HelloWorld& l, const ::IceProxy::HelloWorld& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

void
IceDelegateM::HelloWorld::sayHello(const ::std::string& name, const ::Ice::Context& __context)
{
    static const ::std::string __operation("sayHello");
    ::IceInternal::Outgoing __out(__connection.get(), __reference.get(), __operation, static_cast< ::Ice::OperationMode>(0), __context);
    ::IceInternal::BasicStream* __os = __out.os();
    __os->write(name);
    if(!__out.invoke())
    {
	throw ::Ice::UnknownUserException(__FILE__, __LINE__);
    }
}

void
IceDelegateD::HelloWorld::sayHello(const ::std::string& name, const ::Ice::Context& __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, "sayHello", static_cast< ::Ice::OperationMode>(0), __context);
    while(true)
    {
	::IceInternal::Direct __direct(__current);
	::HelloWorld* __servant = dynamic_cast< ::HelloWorld*>(__direct.facetServant().get());
	if(!__servant)
	{
	    ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
	    __opEx.id = __current.id;
	    __opEx.facet = __current.facet;
	    __opEx.operation = __current.operation;
	    throw __opEx;
	}
	try
	{
	    __servant->sayHello(name, __current);
	    return;
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    throw ::IceInternal::NonRepeatable(__ex);
	}
    }
}

const ::std::string HelloWorld::__ids[2] =
{
    "::HelloWorld",
    "::Ice::Object"
};

bool
HelloWorld::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__ids, __ids + 2, _s);
}

::std::vector< ::std::string>
HelloWorld::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__ids[0], &__ids[2]);
}

const ::std::string&
HelloWorld::ice_id(const ::Ice::Current&) const
{
    return __ids[0];
}

const ::std::string&
HelloWorld::ice_staticId()
{
    return __ids[0];
}

void
HelloWorld::__gcReachable(::IceUtil::GCObjectMultiSet& _c) const
{
#if defined(_MSC_VER) && (MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__gcReachable(_c);
#else
    ::Ice::Object::__gcReachable(_c);
#endif
}

void
HelloWorld::__gcClear()
{
#if defined(_MSC_VER) && (MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__gcClear();
#else
    ::Ice::Object::__gcClear();
#endif
}

::IceInternal::DispatchStatus
HelloWorld::___sayHello(::IceInternal::Incoming& __in, const ::Ice::Current& __current)
{
    ::IceInternal::BasicStream* __is = __in.is();
    ::std::string name;
    __is->read(name);
    sayHello(name, __current);
    return ::IceInternal::DispatchOK;
}

::std::string HelloWorld::__all[] =
{
    "ice_facets",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "sayHello"
};

::IceInternal::DispatchStatus
HelloWorld::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__all, __all + 6, current.operation);
    if(r.first == r.second)
    {
	return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __all)
    {
	case 0:
	{
	    return ___ice_facets(in, current);
	}
	case 1:
	{
	    return ___ice_id(in, current);
	}
	case 2:
	{
	    return ___ice_ids(in, current);
	}
	case 3:
	{
	    return ___ice_isA(in, current);
	}
	case 4:
	{
	    return ___ice_ping(in, current);
	}
	case 5:
	{
	    return ___sayHello(in, current);
	}
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
HelloWorld::__write(::IceInternal::BasicStream* __os, bool __marshalFacets) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os, __marshalFacets);
#else
    ::Ice::Object::__write(__os, __marshalFacets);
#endif
}

void
HelloWorld::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is);
#else
    ::Ice::Object::__read(__is);
#endif
}

void 
::__patch__HelloWorldPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::HelloWorldPtr* p = static_cast< ::HelloWorldPtr*>(__addr);
    assert(p);
    *p = ::HelloWorldPtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::HelloWorld::ice_staticId();
	throw e;
    }
}

bool
operator==(const ::HelloWorld& l, const ::HelloWorld& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
operator!=(const ::HelloWorld& l, const ::HelloWorld& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
operator<(const ::HelloWorld& l, const ::HelloWorld& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
